"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProject = void 0;
const project_1 = require("../5_0/project");
function createProject(ts, host, createLanguageService, options) {
    const { createSymlinkCache } = ts;
    const project = (0, project_1.createProject)(ts, host, createLanguageService, options);
    project.getSymlinkCache = () => {
        if (!project.symlinks) {
            project.symlinks = createSymlinkCache(project.getCurrentDirectory(), project.getCanonicalFileName);
        }
        if (project.program && !project.symlinks.hasProcessedResolutions()) {
            project.symlinks.setSymlinksFromResolutions(
            // @ts-expect-error
            project.program.forEachResolvedModule, 
            // @ts-expect-error
            project.program.forEachResolvedTypeReferenceDirective, 
            // @ts-expect-error
            project.program.getAutomaticTypeDirectiveResolutions());
        }
        return project.symlinks;
    };
    return project;
}
exports.createProject = createProject;
