import * as vue from '@vue/language-core';
import type * as ts from 'typescript/lib/tsserverlibrary';
import type { MetaCheckerOptions, ComponentMeta } from './types';
export * from './types';
export declare function createCheckerByJsonConfigBase(ts: typeof import('typescript/lib/tsserverlibrary'), rootDir: string, json: any, checkerOptions?: MetaCheckerOptions): {
    updateFile(fileName: string, text: string): void;
    deleteFile(fileName: string): void;
    reload(): void;
    clearCache(): void;
    getExportNames: (componentPath: string) => string[];
    getComponentMeta: (componentPath: string, exportName?: string) => ComponentMeta;
    __internal__: {
        tsLs: ts.LanguageService;
    };
};
export declare function createCheckerBase(ts: typeof import('typescript/lib/tsserverlibrary'), tsconfig: string, checkerOptions?: MetaCheckerOptions): {
    updateFile(fileName: string, text: string): void;
    deleteFile(fileName: string): void;
    reload(): void;
    clearCache(): void;
    getExportNames: (componentPath: string) => string[];
    getComponentMeta: (componentPath: string, exportName?: string) => ComponentMeta;
    __internal__: {
        tsLs: ts.LanguageService;
    };
};
export declare function baseCreate(ts: typeof import('typescript/lib/tsserverlibrary'), _host: vue.TypeScriptLanguageHost, vueCompilerOptions: vue.VueCompilerOptions, checkerOptions: MetaCheckerOptions, globalComponentName: string): {
    getExportNames: (componentPath: string) => string[];
    getComponentMeta: (componentPath: string, exportName?: string) => ComponentMeta;
    __internal__: {
        tsLs: ts.LanguageService;
    };
};
//# sourceMappingURL=base.d.ts.map